<?php

/*
 * edit.php - the script to edit/delete/create an song
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 * this script expects the variable $id to contain the song id
 */

chdir("..");
require_once("config.inc");

$HTMLPage->set_title("edit muwed song entry");

if($CSS_FILE!=false)
  $HTMLPage->push_css_link("../$CSS_FILE");

$table1=new TABLEtag(array("CELLSPACING" => "$TABLE_SPACING",
                           "CELLPADDING" => "0",
                           "BORDER" => "$TABLE_BORDER",
                           "WIDTH" => "$MAX_TABLE_WIDTH",
                           "HEIGHT" => "$MAX_TABLE_HEIGHT"));

$table2=new TABLEtag(array("WIDTH" => "100%"));
$table2->push_row(create_TD(array("class" => "Name", "ALIGN" => "MIDDLE"), "edit muwed song entry"));
$table1->push_row(create_TD(array("class" => "Title", "VALIGN"=>"TOP"), $table2));

if(!$conn)
  $conn=pg_pconnect($DBCONNECT);
if(!$conn)
{
  $table1->push_row(create_TD(array("class"=>"Navigation", "WIDTH"=>"100%", "ALIGN"=>"CENTER"),
                              create_B("Failed to open the database with \"$DBCONNECT\"")));
}
else
{
  $fields="";
  $columns="";
  $values="";

  reset($HTTP_GET_VARS);
  while(list($key, $val)=each($HTTP_GET_VARS)) 
  {
    if($key != "id" && $key != "cmd")
    {
      if($fields != "")
        $fields.=", ";

      if($columns != "")
        $columns.=", ";

      if($values != "")
        $values.=", ";

      if($key=="flags" && strncmp($val, "0x", 2)==0)
        $val=hexdec($val);

      if($val == "")
        $val="NULL";
      else
        $val="'$val'";

      $fields.="$key=$val";
      $columns.="$key";
      $values.="$val";
    }
  }

  $err=false;
  $msg=false;
  if($cmd == "update")
  {
    $result=pg_exec($conn, "UPDATE songs SET $fields WHERE id=$id;");

    if($result == false)
      $msg="failed updating entry";
    else
      $msg="updated entry";
 
    $err=pg_errormessage($conn);
  }
  else if($cmd == "create")
  {
    $result=pg_exec($conn, "INSERT INTO songs ($columns) VALUES ($values);");

    if($result == false)
      $msg="failed creating new entry";
    else
    {
      $msg="created new entry";

      $oid=pg_getlastoid($result);
      $result=pg_exec($conn, "SELECT id FROM songs WHERE oid=$oid;");
      
      $ida=pg_fetch_array($result, 0);
      $id=$ida[0];
    }

    $err=pg_errormessage($conn);
  }
  else if($cmd == "delete")
  {
    $result=pg_exec($conn, "DELETE FROM songs WHERE id=$id;");

    if($result == false)
      $msg="failed deleting entry";
    else
      $msg="deleted entry";

    $err=pg_errormessage($conn);
  }
 
  if($msg!=false)
  {
    if($err!=false)
      $err="<BR>".$err;

    $table1->push_row(create_TD(array("class"=>"Navigation", "WIDTH"=>"100%", "ALIGN"=>"CENTER"), array(create_B($msg), $err)));
  }

  $result=pg_exec($conn,"SELECT * FROM songs WHERE id=$id;");

  $entries_found=pg_numrows($result);
  
  if($entries_found > 0)
  {
    // let's create the update form
    $song=pg_fetch_array($result, 0);

    $updateform=new FORMtag(array("NAME"=>"updateform", "ACTION"=>"edit.php", "METHOD"=>"GET"));
    $updateform->push(form_hidden("id", "$id"));
    

    $table2=new TABLEtag(array("CELLSPACING"=>"4",
                               "CELLPADDING"=>"0",
                               "BORDER"=>"$TABLE_BORDER",
                               "WIDTH" => "100%"));

    $table2->push_row(create_TD(array("class"=>"Column", "ALIGN"=>"CENTER", "WIDTH"=>"50%"), create_B("Field:")),
                      create_TD(array("class"=>"Column", "ALIGN"=>"CENTER"), create_B("Value:")));

    for($i=0; $i<pg_numfields($result); $i++)
    {
      $name=pg_fieldname($result, $i);
      $uname=ucfirst($name);

      if($name=="flags")
        $val=sprintf("0x%08X", $song[$i]);
      else
        $val=$song[$i];
      $val=htmlspecialchars($val);

      if($name != "id")
      {
        $row=new TRtag();

        $row->push(create_TD(array("CLASS"=>"Entry", "ALIGN"=>"LEFT"), create_B("$uname:")));
        $row->push(create_TD(array("CLASS"=>"Entry", "ALIGN"=>"LEFT"), form_text("$name", "$val", "$EDIT_SIZE")));

        $table2->push($row);
      }
    }

    $updateform->push(create_TR(create_TD(array("class"=>"Content", "VALIGN"=>"TOP", "HEIGHT"=>"100%"), $table2)));

    $table2=new TABLEtag(array("WIDTH" => "100%"));

    $table2->push_row(create_TD(array("CLASS"=>"Name", "ALIGN"=>"CENTER"), form_submit("cmd", "update")),
                      create_TD(array("CLASS"=>"Name", "ALIGN"=>"CENTER"), form_submit("cmd", "create")),
                      create_TD(array("CLASS"=>"Name", "ALIGN"=>"CENTER"), form_submit("cmd", "delete")),
                      create_TD(array("CLASS"=>"Name", "ALIGN"=>"CENTER"), new INPUTtag(array("TYPE"=>"reset", "VALUE"=>"reset"))));

    if($HAS_JS)
      $table2->push_row(create_TD(array("class"=>"Name", "ALIGN"=>"CENTER", "COLSPAN"=>"4"), array("[", html_a("javascript:window.close()", "close"), "]")));

    $updateform->push(create_TR(create_TD(array("class"=>"Title", "VALIGN"=>"TOP"), $table2)));
  
    $table1->push($updateform);
  }
  else if($HAS_JS)
  {
    $table2=new TABLEtag(array("WIDTH" => "100%"));
    $table2->push_row(create_TD(array("class"=>"Name", "ALIGN"=>"CENTER"), array("[", html_a("javascript:window.close()", "close"), "]")));

    $table1->push_row(create_TD(array("class"=>"Title", "VALIGN"=>"TOP"), $table2));
  }
}

$HTMLPage->push($table1);
print $HTMLPage->render();

?>
