<?php

/* 
 * plqueryform.inc - the script to display the playlist query form and set default values. 
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 */

require_once("config.inc");

function createPLQueryField_TABLE()
{
  global $pltitle, $songid;
  global $match, $regex, $case, $plsortby;
  global $PLTITLE_SIZE, $SONGID_SIZE, $SHOW_COLUMN, $HAS_JS;

  $regex=($regex === 0) ? 0 : 1;	// fore regex default is true

  $etitle=htmlspecialchars($pltitle);
  $esongid=htmlspecialchars($songid);

  $table1=new TABLEtag(array("WIDTH"=>"100%"));

  $table2=new TABLEtag(array("WIDTH"=>"100%"));
  $table2->push_row(
      create_TD(array("CLASS"=>"Name", "ALIGN"=>"MIDDLE"), array("muwed", html_a("search.php", "search song"), " / ", html_a("plsearch.php", "search playlist"))),
      create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), html_b(html_a("plsearchhelp.php", "help", NULL, "search_help"))));

  $fieldsTD=create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"));

  $fieldsTD->push("Title:", form_text("pltitle", "$etitle", "$PLTITLE_SIZE"));
  $fieldsTD->push("Song ID: #", form_text("songid", "$esongid", "$SONGID_SIZE"));

  $matchsel=($match == "AND") ? "ALL" : "ANY";
  $regexattr=($regex == 1) ? array("CHECKED") : array();
  $caseattr=($case == 1) ? array("CHECKED") : array();

  $resetInp=array();
  if($HAS_JS)
  {
    $onclk="javascript: document.plqform.pltitle.value=''; document.plqform.songid.value='';";

    $resetInp=form_button("Reset", "Reset", array("ONCLICK"=>$onclk));
  }

  $table2->push_row(
      $fieldsTD,
      create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), form_submit("Search", "Search")));

  $table2->push_row(
      create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), array(
        "Match:", form_select("match", array("ALL"=>"AND", "ANY"=>"OR"), $matchsel),
        form_checkbox("regex", "1", $regexattr), "regex",
        form_checkbox("case", "1", $caseattr), "case sensitive",
        form_hidden("plsortby", "$plsortby"))),
      create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), $resetInp));

  $table1->push_row(create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), $table2));

  return $table1;
}
