<?php

/* 
 * plsearch.php - the script to perform a playlist database search
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 * this script expects the variable $pltitle, $songid to be set to perform a query.
 *
 */

require_once("selentries.inc");	// get selected entries from session
require_once("dbutils.inc");
require_once("plqueryform.inc");
require_once("dbplquery.inc");
require_once("aboutmuwed.inc");

$HTMLPage->set_title("muwed song search");

if($CSS_FILE!=false)
  $HTMLPage->push_css_link($CSS_FILE);

if($HAS_JS)
  $HTMLPage->push_js_link("muwedSearch.js");

$table1=new TABLEtag(array("CELLSPACING" => "$TABLE_SPACING",
                           "CELLPADDING" => "0",
                           "BORDER" => "$TABLE_BORDER",
                           "WIDTH" => "$MAX_TABLE_WIDTH",
                           "HEIGHT" => "$MAX_TABLE_HEIGHT"));

$pltitle=stripslashes($pltitle);
$songid=stripslashes($songid);

$plqform=new FORMtag(array("NAME"=>"plqform", "ACTION"=>"plsearch.php", "METHOD"=>"GET", "TARGET"=>"muwed"));
$plqform->push(create_TR(create_TD(array("CLASS"=>"Search", "VALIGN"=>"TOP"), createPLQueryField_TABLE())));

// formulate the query
$clauses=array();

if(strlen($pltitle) > 0)
  array_push($clauses, getQueryClause("title", $pltitle, $regex, $case));

if($SHOW_COLUMN["album"] && strlen($album) > 0)
  array_push($clauses, getQueryClause("album", $album, $regex, $case));

if(is_numeric($songid))	// no need to look for non int IDs :-)
{
  array_push($clauses, getPlaylistWithSongClause($songid));
}

// do we realy have a query
if(sizeof($clauses) > 0 || count($selEntries)>0)
{
  $plquery=joinClauses($match, $clauses);

  $result=createPLSearch_TABLE($plquery, "No entries found matching the given pattern", true);
}
else // no query to ask the database
  $result=createAbout_TABLE();

$plqform->push(create_TR(create_TD(array("CLASS"=>"Content", "VALIGN"=>"TOP", "HEIGHT"=>"100%"), $result)));
$table1->push($plqform);
$HTMLPage->push($table1);
print $HTMLPage->render();

?>
